package com.ruoyi.hezhi.api.common;

import cn.hutool.core.lang.Snowflake;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.enums.ServiceResponseEnum;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.qiniu.QiNiuUploadUtils;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.ImgUpload;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.common.utils.file.MimeTypeUtils;
import com.ruoyi.common.utils.uuid.Seq;
import com.ruoyi.hezhi.domain.dto.BannerDTO;
import com.ruoyi.hezhi.domain.vo.*;
import com.ruoyi.hezhi.service.*;
import com.ruoyi.system.service.ISysDictDataService;
import io.swagger.annotations.Api;
import org.apache.commons.io.FilenameUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.InputStream;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.util.*;

/**
 * @Author: cc
 * @Date: 2024/4/2
 * @Description:通用API
 */
@Api("通用")
@RestController
@RequestMapping("/api/common")
public class ApiCommonController {
    @Resource
    private QiNiuUploadUtils qiNiuUploadUtils;

    @Resource
    private ITbBannerService bannerService;

    @Resource
    private ITbNewsService newsService;

    @Resource
    private ITbTrendsService tbTrendsService;

    @Resource
    private ITbCaseTypeService caseTypeService;

    @Resource
    private ITbCaseService caseService;

    @Resource
    private ITbNoticeService noticeService;

    @Resource
    private ITbTeacherService tbTeacherService;

    @Resource
    private ISysDictDataService dictDataService;

    private static final String FILE_DELIMETER = ",";

    /**
     * 获取字典参数列表
     * @param paramType 字典类型（0-企业规模）
     * @return 结果
     */
    @GetMapping("/getDictParamList")
    public AjaxResult getDictParamList(String paramType){
        List<DictParamVO> dictParamList = dictDataService.getDictParamList(paramType);
        return AjaxResult.success(dictParamList);
    }

    // /**
    //  * 通用上传请求（本地单个）
    //  */
    // @RepeatSubmit
    // @PostMapping("/uploadImage")
    // public AjaxResult uploadImage(MultipartFile file){
    //     if (file.isEmpty()){
    //         throw new ServiceException(ServiceResponseEnum.UPLOAD_FILE_NOT_NULL);
    //     }
    //     try{
    //         // 接口返回参数
    //         Map<String, Object> returnMap = new HashMap<>();
    //
    //         // 文件上传名称
    //         String fileUploadName = qiNiuUploadUtils.getFileUploadName(file);
    //         // 上传（压缩后图片）
    //         String url = qiNiuUploadUtils.uploadByte(QiNiuUploadUtils.getZipImage(file), fileUploadName);
    //         if (StringUtils.isBlank(url)){
    //             throw new ServiceException(ServiceResponseEnum.UPLOAD_FILE_FAILED);
    //         }
    //         returnMap.put("imageUrl", url);
    //         return AjaxResult.success(returnMap);
    //     }catch (Exception e){
    //         e.printStackTrace();
    //         return AjaxResult.error(Constants.EXCEPTION_MSG);
    //     }
    // }

    /**
     * 通用上传请求（七牛云单个）
     */
    // @RepeatSubmit
    @PostMapping("/uploadImage")
    public AjaxResult uploadImage(MultipartFile file){
        if (file.isEmpty()){
            throw new ServiceException(ServiceResponseEnum.UPLOAD_FILE_NOT_NULL);
        }
        try{
            String fileName = null;

            // 接口返回参数
            String originalFilename = file.getOriginalFilename();
            Map<String, Object> returnMap = new HashMap<>();

            // 文件名称
            String key = StringUtils.format("{}/{}/{}_{}.{}", "xxks", DateUtils.datePath(),
                    md5HashCode(file.getInputStream()), Seq.getId(Seq.uploadSeqType), getExtension(file));

            String imagePath = new ImgUpload().upload(file.getBytes(), key);
            if (StringUtils.isBlank(imagePath)) {
                return  AjaxResult.error("上传失败");
            }
            returnMap.put("fileName", originalFilename);
            returnMap.put("url", imagePath);
            return AjaxResult.success(returnMap);
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error(Constants.EXCEPTION_MSG);
        }
    }

    /**
     * java获取文件的md5值
     * @param fis 输入流
     * @return 结果
     */
    public static String md5HashCode(InputStream fis) {
        try {
            //拿到一个MD5转换器,如果想使用SHA-1或SHA-256，则传入SHA-1,SHA-256
            MessageDigest md = MessageDigest.getInstance("MD5");

            //分多次将一个文件读入，对于大型文件而言，比较推荐这种方式，占用内存比较少。
            byte[] buffer = new byte[1024];
            int length = -1;
            while ((length = fis.read(buffer, 0, 1024)) != -1) {
                md.update(buffer, 0, length);
            }
            fis.close();
            //转换并返回包含16个元素字节数组,返回数值范围为-128到127
            byte[] md5Bytes  = md.digest();
            BigInteger bigInt = new BigInteger(1, md5Bytes);//1代表绝对值
            return bigInt.toString(16);//转换为16进制
        } catch (Exception e) {
            e.printStackTrace();
            return "";
        }
    }

    /**
     * 获取文件名的后缀
     *
     * @param file 表单文件
     * @return 后缀名
     */
    public static String getExtension(MultipartFile file)
    {
        String extension = FilenameUtils.getExtension(file.getOriginalFilename());
        if (org.apache.commons.lang3.StringUtils.isEmpty(extension))
        {
            extension = MimeTypeUtils.getExtension(Objects.requireNonNull(file.getContentType()));
        }
        return extension;
    }

    /**
     * 通用上传请求（多个）
     */
    @PostMapping("/uploadFiles")
    public AjaxResult uploadFiles(List<MultipartFile> files) throws Exception
    {
        try
        {
            // 上传文件路径
            // String filePath = RuoYiConfig.getUploadPath();
            List<String> urls = new ArrayList<String>();
            List<String> fileNames = new ArrayList<String>();
            List<String> newFileNames = new ArrayList<String>();
            List<String> originalFilenames = new ArrayList<String>();
            for (MultipartFile file : files)
            {
                // 文件上传名称
                String fileUploadName = qiNiuUploadUtils.getFileUploadName(file);
                // 上传（压缩后图片）
                String url = qiNiuUploadUtils.uploadByte(file.getBytes(), new Snowflake(0, 0).nextIdStr() +"_"+fileUploadName);
                if (StringUtils.isBlank(url)){
                    throw new ServiceException("上传失败");
                }
                urls.add(url);
                fileNames.add(fileUploadName);
                newFileNames.add(FileUtils.getName(fileUploadName));
                originalFilenames.add(file.getOriginalFilename());
            }
            AjaxResult ajax = AjaxResult.success();
            ajax.put("urls", StringUtils.join(urls, FILE_DELIMETER));
            ajax.put("fileNames", StringUtils.join(fileNames, FILE_DELIMETER));
            ajax.put("newFileNames", StringUtils.join(newFileNames, FILE_DELIMETER));
            ajax.put("originalFilenames", StringUtils.join(originalFilenames, FILE_DELIMETER));
            return ajax;
        }
        catch (Exception e)
        {
            return AjaxResult.error(e.getMessage());
        }
    }


    /**
     * 查询轮播图通用
     * @return 结果
     */
    @GetMapping("/selectBannerList")
    public AjaxResult selectBannerList(BannerDTO banner){
        List<BannerVO> result = bannerService.selectBannerListForXcxCommon(banner);
        return AjaxResult.success(result);
    }

    /**
     * 查询新闻列表
     * @return 结果
     */
    @GetMapping("/selectNewsList")
    public AjaxResult selectNewsList(){
        List<NewsVO> list = newsService.getNewsList();
        return AjaxResult.success(list);
    }

    /**
     * 获取新闻详情
     * @return 结果
     */
    @GetMapping("/selectNewsInfo")
    public AjaxResult selectNewsInfo(@RequestParam Long id){
            return AjaxResult.success(newsService.getDetail(id));
    }

    /**
     * 查询动态列表
     * @return 结果
     */
    @GetMapping("/selectTrendsList")
    public AjaxResult selectTrendsList(){
        List<TrendsVO> list = tbTrendsService.getTrendsVoList();
        return AjaxResult.success(list);
    }

    /**
     * 获取动态详情
     * @return 结果
     */
    @GetMapping("/selectTrendsInfo")
    public AjaxResult selectTrendsInfo(@RequestParam Long id){
        return AjaxResult.success(tbTrendsService.getDetail(id));
    }

    /**
     * 查询案例分类列表
     * @return 结果
     */
    @GetMapping("/selectCaseTypeList")
    public AjaxResult selectCaseTypeList(){
        List<CaseTypeVO> list = caseTypeService.getCaseTypeList();
        return AjaxResult.success(list);
    }

    /**
     * 查询案例列表 by分类
     * @param typeId
     * @return
     */
    @GetMapping("/selectCaseList")
    public AjaxResult selectCaseList(@RequestParam Long typeId){
        List<CaseVO> list = caseService.selectCaseListByType(typeId);
        return AjaxResult.success(list);
    }

    /**
     * 获取案例详情
     * @return 结果
     */
    @GetMapping("/selectCaseInfo")
    public AjaxResult selectCaseInfo(@RequestParam Long id){
        return AjaxResult.success(caseService.getDetail(id));
    }

    /**
     * 查询公告列表
     * @return 结果
     */
    @GetMapping("/selectNoticeList")
    public AjaxResult selectNoticeList(){
        List<NoticeVO> list = noticeService.getNoticeList();
        return AjaxResult.success(list);
    }

    /**
     * 获取公告详情
     * @return 结果
     */
    @GetMapping("/selectNoticeInfo")
    public AjaxResult selectNoticeInfo(@RequestParam Long id){
        return AjaxResult.success(noticeService.getDetail(id));
    }

    /**
     * 查询教师列表
     * @return 结果
     */
    @GetMapping("/selectTeacherList")
    public AjaxResult selectTeacherList(@RequestParam Long typeId){
        List<TeacherVO> list = tbTeacherService.selectTeacherListByType(typeId);
        return AjaxResult.success(list);
    }

    /**
     * 获取教师详情
     * @return 结果
     */
    @GetMapping("/selectTeacherInfo")
    public AjaxResult selectTeacherInfo(@RequestParam Long id){
        return AjaxResult.success(tbTeacherService.getDetail(id));
    }

}
